#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#include <stdlib.h>
#include <stdio.h>

volatile sig_atomic_t segnale_padre;
volatile sig_atomic_t segnale_figlio;
enum { MAX_PINGS = 10 };

void sigint_handler_figlio(int sig)
{
  segnale_figlio = 1;
}

void sigint_handler_padre(int sig)
{
  segnale_padre = 1;
}

int main(int argc, char * argv[])
{
  segnale_padre = 0;
  segnale_figlio = 0;
  pid_t pid;
  pid = fork();
  if (pid == 0) { // processo figlio
    if (signal(SIGINT, sigint_handler_figlio) == SIG_ERR) { // registriamo il gestore di segnali
      exit(1);
    }
	pid_t pid_padre = getppid();
	while(1) {
		while (segnale_figlio != 1) { // attendiamo che il segnale sia ricevuto
			sleep(1);
		}
		printf("Ping!\n");
		sleep(1);
		segnale_figlio = 0;
		kill(pid_padre, SIGINT); // inviamo un segnale SIGINT al processo padre
	}
  } else { // processo padre
	if (signal(SIGINT, sigint_handler_padre) == SIG_ERR) { // registriamo il gestore di segnali
		exit(1);
    }
	sleep(1);
	kill(pid, SIGINT);  // primo segnale
    for (int pings = 0; pings < MAX_PINGS; pings++) {
		while (segnale_padre != 1) { // attendiamo che il segnale sia ricevuto
			sleep(1);
		}
		printf("\tPong!\n");
		sleep(1);
		segnale_padre = 0;
		kill(pid, SIGINT); // inviamo un segnale SIGINT al processo figlio
	}
	kill(pid, SIGTERM);
  }
  return 0;
}