#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>

int main(int argc, char* argv[]) {
    int fd1[2];
	int fd2[2];
    if (pipe(fd1) == -1 || pipe(fd2) == -1) {
        return 1;
    }
    
    int pid = fork();
    if (pid == -1) {
        return 2;
    }
	
	if (pid > 0) {
		// Parent process
		close(fd1[0]);
		int i;
		int n;
		n = 10;
		int arr[n];
		srand(time(NULL));
		printf("Generated: ");
		for(i = 0; i < n; i++){
			arr[i] = rand() % 11;
			printf("%d ", arr[i]);
		}
		printf("\n");
		if (write(fd1[1], &n, sizeof(int)) < 0) {
            return 3;
        }
		printf("Sent n = %d\n", n);
		if (write(fd1[1], &arr, sizeof(int) * n) < 0) {
            return 4;
        }
		printf("Sent array\n");
		close(fd1[1]);
		close(fd2[1]);
		int sum;
		if (read(fd2[0], &sum, sizeof(int)) < 0) {
            return 5;
        }
		printf("Recieved the Sum: %d\n", sum);
		
    } else {
	
        close(fd1[1]);
        int n, i, sum = 0;
        
        if (read(fd1[0], &n, sizeof(int)) < 0) {
            return 6;
        }
		int arr[n];
        printf("\tReceived n = %d\n", n);
        if (read(fd1[0], &arr, sizeof(int) * n) < 0) {
            return 7;
        }
        printf("\tReceived array\n");
        
        close(fd1[0]);
		close(fd2[0]);
        for (i = 0; i < n; i++) {
            sum += arr[i];
        }
		if (write(fd2[1], &sum, sizeof(int)) < 0) {
            return 8;
        }
		printf("\tSum sent\n");
		close(fd2[1]);
    }
    
    return 0;
}